/*********************************************************************************/
/********** THIS FILE IS GENERATED BY TOUCHGFX DESIGNER, DO NOT MODIFY ***********/
/*********************************************************************************/
#ifndef MAINVIEWBASE_HPP
#define MAINVIEWBASE_HPP

#include <gui/common/FrontendApplication.hpp>
#include <mvp/View.hpp>
#include <gui/main_screen/MainPresenter.hpp>
#include <touchgfx/widgets/Box.hpp>
#include <touchgfx/widgets/Image.hpp>
#include <touchgfx/widgets/TextAreaWithWildcard.hpp>
#include <touchgfx/widgets/Button.hpp>
#include <touchgfx/widgets/ButtonWithLabel.hpp>
#include <touchgfx/widgets/TextArea.hpp>

class MainViewBase : public touchgfx::View<MainPresenter>
{
public:
    MainViewBase();
    virtual ~MainViewBase() {}
    virtual void setupScreen();

    /*
     * Virtual Action Handlers
     */
    virtual void increaseMinValue()
    {
        // Override and implement this function in Main
    }

    virtual void decreaseMinValue()
    {
        // Override and implement this function in Main
    }

    virtual void increaseSecValue()
    {
        // Override and implement this function in Main
    }

    virtual void decreaseSecValue()
    {
        // Override and implement this function in Main
    }

    virtual void reset()
    {
        // Override and implement this function in Main
    }

    virtual void start()
    {
        // Override and implement this function in Main
    }

protected:
    FrontendApplication& application() {
        return *static_cast<FrontendApplication*>(touchgfx::Application::getInstance());
    }

    /*
     * Member Declarations
     */
    touchgfx::Box __background;
    touchgfx::Image backgroundImage;
    touchgfx::Image counterBackgroundImage;
    touchgfx::TextAreaWithOneWildcard minTxt;
    touchgfx::Button buttonMinUp;
    touchgfx::Button buttonMinDown;
    touchgfx::ButtonWithLabel buttonStart;
    touchgfx::ButtonWithLabel buttonReset;
    touchgfx::Image counterBackgroundImage_1;
    touchgfx::TextAreaWithOneWildcard secTxt;
    touchgfx::Button buttonSecUp;
    touchgfx::Button buttonSecDown;
    touchgfx::TextArea textColumn;

    /*
     * Wildcard Buffers
     */
    static const uint16_t MINTXT_SIZE = 3;
    touchgfx::Unicode::UnicodeChar minTxtBuffer[MINTXT_SIZE];
    static const uint16_t SECTXT_SIZE = 3;
    touchgfx::Unicode::UnicodeChar secTxtBuffer[SECTXT_SIZE];

private:

    /*
     * Callback Declarations
     */
    touchgfx::Callback<MainViewBase, const touchgfx::AbstractButton&> buttonCallback;

    /*
     * Callback Handler Declarations
     */
    void buttonCallbackHandler(const touchgfx::AbstractButton& src);

};

#endif // MAINVIEWBASE_HPP
